//**************************************************************************
//* exceptions.h
//*
//* description    : Exceptions which could be generated by this
//*                  program
//* copyright      : (C) 2001 Cedric de Launois
//*                  Universite Catholique de Louvain, Belgium
//* begin          : Sept 11 2001
//* email          : cedric@delaunois.org
//**************************************************************************

/****************************************************************************
 * Copyright (c) 1998 Free Software Foundation, Inc.                        *
 *                                                                          *
 * Permission is hereby granted, free of charge, to any person obtaining a  *
 * copy of this software and associated documentation files (the            *
 * "Software"), to deal in the Software without restriction, including      *
 * without limitation the rights to use, copy, modify, merge, publish,      *
 * distribute, distribute with modifications, sublicense, and/or sell       *
 * copies of the Software, and to permit persons to whom the Software is    *
 * furnished to do so, subject to the following conditions:                 *
 *                                                                          *
 * The above copyright notice and this permission notice shall be included  *
 * in all copies or substantial portions of the Software.                   *
 *                                                                          *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS  *
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF               *
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.   *
 * IN NO EVENT SHALL THE ABOVE COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,   *
 * DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR    *
 * OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR    *
 * THE USE OR OTHER DEALINGS IN THE SOFTWARE.                               *
 *                                                                          *
 * Except as contained in this notice, the name(s) of the above copyright   *
 * holders shall not be used in advertising or otherwise to promote the     *
 * sale, use or other dealings in this Software without prior written       *
 * authorization.                                                           *
 ****************************************************************************/

#ifndef _EXCEPTIONS_H_
#define _EXCEPTIONS_H_

// Global/Unspecified Exceptions
class Exception { public: Exception() {}; };
class NotEnoughMemory    : public Exception {};

// Network Exceptions
class NetworkException   : public Exception { public: NetworkException() {}; };
class SocketOpeningError : public NetworkException {};
class BindError          : public NetworkException {};
class ListenError        : public NetworkException {};
class ConnectError       : public NetworkException {};
class AcceptError        : public NetworkException {};
class SelectError        : public NetworkException {};
class SocketReadError    : public NetworkException {};
class SocketWriteError   : public NetworkException {};
class ClosedPortError    : public NetworkException {};
class BadPort            : public NetworkException {};

// Message Processing Exceptions
class MsgException       : public Exception { public: MsgException() {}; };
class ForgeException     : public MsgException {};

#endif
