//***************************************************************************
//* log.h
//*
//* description    : logging function : implementation
//* copyright      : (C) 2001 Cedric de Launois
//*                  Universite Catholique de Louvain, Belgium
//* begin          : Sept 24 2001
//* email          : cedric@delaunois.org
//***************************************************************************

/****************************************************************************
 * Copyright (c) 1998 Free Software Foundation, Inc.                        *
 *                                                                          *
 * Permission is hereby granted, free of charge, to any person obtaining a  *
 * copy of this software and associated documentation files (the            *
 * "Software"), to deal in the Software without restriction, including      *
 * without limitation the rights to use, copy, modify, merge, publish,      *
 * distribute, distribute with modifications, sublicense, and/or sell       *
 * copies of the Software, and to permit persons to whom the Software is    *
 * furnished to do so, subject to the following conditions:                 *
 *                                                                          *
 * The above copyright notice and this permission notice shall be included  *
 * in all copies or substantial portions of the Software.                   *
 *                                                                          *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS  *
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF               *
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.   *
 * IN NO EVENT SHALL THE ABOVE COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,   *
 * DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR    *
 * OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR    *
 * THE USE OR OTHER DEALINGS IN THE SOFTWARE.                               *
 *                                                                          *
 * Except as contained in this notice, the name(s) of the above copyright   *
 * holders shall not be used in advertising or otherwise to promote the     *
 * sale, use or other dealings in this Software without prior written       *
 * authorization.                                                           *
 ****************************************************************************/


#include "log.h"

int log_level = LOG_DEBUG;
int log_output = LOG_CONS;

void setloglevel(int level) { log_level = level; }
void setlogoutput(int output) { log_output = output; }

void logmsg(int level, const char *fmt, ...)
{
	if (level > log_level) return;
	openlog("rsipd", log_output, LOG_DAEMON);

	char s[255];

	time_t now = time(0);
	char* c = ctime(&now);
	c[24] = ' ';

	snprintf(s, 28, "%s: ", c);

	va_list ap;
	va_start(ap,fmt);
	vsnprintf(s+27, 215, fmt, ap);
	va_end(ap);

	syslog(level, s);
}

void logconsole(int level, const char *fmt, ...)
{
	openlog("rsipd", LOG_PERROR, LOG_DAEMON);

	char s[100];
	time_t now = time(0);
	char* c = ctime(&now);
	c[24] = ' ';

	snprintf(s, 28, "%s: ", c);

	va_list ap;
	va_start(ap,fmt);
	vsnprintf(s+27, 73, fmt, ap);
	va_end(ap);

	syslog(level, s);
}
