//***************************************************************************
//* Id: slp.cpp,v 0.1 2002/01/10 21:45:32 jose Exp
//*
//* Copyright 2001-2002 Jose Vasconcellos
//*                     Cedric de Launois
//***************************************************************************

/****************************************************************************
 * Copyright (c) 1998 Free Software Foundation, Inc.                        *
 *                                                                          *
 * Permission is hereby granted, free of charge, to any person obtaining a  *
 * copy of this software and associated documentation files (the            *
 * "Software"), to deal in the Software without restriction, including      *
 * without limitation the rights to use, copy, modify, merge, publish,      *
 * distribute, distribute with modifications, sublicense, and/or sell       *
 * copies of the Software, and to permit persons to whom the Software is    *
 * furnished to do so, subject to the following conditions:                 *
 *                                                                          *
 * The above copyright notice and this permission notice shall be included  *
 * in all copies or substantial portions of the Software.                   *
 *                                                                          *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS  *
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF               *
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.   *
 * IN NO EVENT SHALL THE ABOVE COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,   *
 * DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR    *
 * OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR    *
 * THE USE OR OTHER DEALINGS IN THE SOFTWARE.                               *
 *                                                                          *
 * Except as contained in this notice, the name(s) of the above copyright   *
 * holders shall not be used in advertising or otherwise to promote the     *
 * sale, use or other dealings in this Software without prior written       *
 * authorization.                                                           *
 ****************************************************************************/

#include "slp.h"

void slpCallback(SLPHandle h, SLPError err, void *cookie)
{
	*((SLPError *)cookie) = err;
}


int registerWithSlp(const Address &address)
{
	SLPHandle h;
	SLPError err, callbackerr;
	char buffer[80];

	logmsg(LOG_INFO,"Registering %s://%s:%d with SLP\n",
	       RSIP_SRVURL, address.toChar(), address.getPort());
	
	sprintf(buffer,"%s://%s:%d", RSIP_SRVURL,
		address.toChar(), address.getPort());

	if ((err = SLPOpen((const char*)NULL, (SLPBoolean)0, &h)) != SLP_OK) {
		logmsg(LOG_WARNING, "Unable to connect to SLP DA %d\n", err);
		return -1;
	}

	err = SLPReg(h, buffer, SLP_LIFETIME_MAXIMUM, NULL, RSIP_ATTR,
		     SLP_TRUE, slpCallback, &callbackerr);
	SLPClose(h);

	if ((err != SLP_OK) && (callbackerr != SLP_OK)) {
		logmsg(LOG_WARNING, "Unable to register with SLP DA %d\n", err);
		return -1;
	}

	return 0;
}
